# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Attributes
dirac::TransformByteIO Class Reference

Represents compressed sequence-parameter data used in an AccessUnit.

`#include <transform_byteio.h>`

Inheritance diagram for dirac::TransformByteIO:

List of all members.

## Public Member Functions
| TransformByteIO (PictureParams &fparams, CodecParams &c_params)
| Output Constructor.
| TransformByteIO (ByteIO &byte_io, PictureParams &fparams, CodecParams &c_params)
| Input Constructor.
virtual | ~TransformByteIO ()
| Destructor.
void | CollateByteStats (DiracByteStats &dirac_byte_stats)
| Gathers byte stats on the transform data.
void | Output ()
| Outputs sequence information to Dirac byte-format.
void | Input ()
| Outputs sequence information to Dirac byte-format.
virtual const std::string | GetBytes ()
| Get string containing coded bytes.
int | GetSize () const
| Return the size.
void | AddComponent (ComponentByteIO *component_byteio)
| Adds a Picture-component in Dirac-bytestream format.
Public Member Functions inherited from dirac::ByteIO
| ByteIO (bool new_stream=true)
| Default constructor.
| ByteIO (const ByteIO &stream_data)
| Constructor.
virtual | ~ByteIO ()
| Destructor.
int | GetReadBytePosition () const
| Get position of read stream pointer.
void | SetByteParams (const ByteIO &byte_io)
| Copies stream source/destination info.
void | ByteAlignOutput ()
| Sync input for byte-alignment.
void | WriteUint (unsigned int value)
| Ouputs an unsigned integer in interleaved exp Golomb format.
void | SetBitsLeft (int left_bits)
| Sets input size in bits.
int | BitsLeft (void)
| Sets input size in bits.

## Private Attributes
PictureParams & | m_fparams
| Sequence paramters for intput/output.
CodecParams & | m_cparams
| Codec params - EncParams for Output and DecParams for input.
CodecParams | m_default_cparams
| Default Codec params - EncParams for Output and DecParams for input.
std::vector< ComponentByteIO * > | m_component_list

## Additional Inherited Members
Protected Member Functions inherited from dirac::ByteIO
bool | CanRead () const
bool | GetBit (unsigned char &c, int pos) const
void | SetBit (unsigned char &c, int pos) const
void | SetBits (unsigned char &c, unsigned char bits) const
void | ByteAlignInput ()
| Sync input for byte-alignment.
bool | ReadBool ()
| Reads boolean value.
bool | ReadBoolB ()
| Reads boolean value - bounded i/o.
int | ReadBit ()
| Reads next bit.
int | ReadBitB ()
| Reads next bit - bounded i/o.
unsigned int | ReadNBits (int count)
| Reads next 'count' bits.
void | InputBytes (char *data, int count)
| Reads from stream.
void | FlushInputB ()
| Flushes the bounde input.
int | ReadSint ()
| Reads a signed integer in interleaved exp-Golomb format *return Signed integer read.
int | ReadSintB ()
| Reads a signed integer in interleaved exp-Golomb format from bounded input *return Signed integer read.
unsigned int | ReadUint ()
| Reads an unsigned integer in interleaved exp Golomb format.
unsigned int | ReadUintB ()
| Reads an unsigned integer in interleaved exp Golomb format from bounded input.
unsigned int | ReadUintLit (const int byte_size)
| Reads a fixed length unsigned integer from the stream in big endian.
unsigned char | InputUnByte ()
| Reads a byte from the stream.
std::string | InputUnString (const int count)
| Reads a series of bytes from a stream.
void | WriteBit (const bool &bit)
| Outputs a bit.
int | WriteNBits (unsigned int val)
| Outputs an unsigned integer.
void | WriteNBits (unsigned int val, int count)
| Outputs an n bit integer.
void | OutputBytes (const std::string &bytes)
| Outputs a series of bytes.
void | OutputCurrentByte ()
| Outputs current byte contents.
void | WriteSint (int val)
| Outputs an integer in Golomb signed integer format.
void | WriteUintLit (const unsigned int &value, const int &length)
| Output unsigned int value in big endian format.
void | RemoveRedundantBytes (const int count)
| Removes portion of byte-stream no longer required.
void | SeekGet (const int offset, std::ios_base::seekdir dir)
Protected Attributes inherited from dirac::ByteIO
std::stringstream * | mp_stream
| Input/output steam.

## Constructor & Destructor Documentation

dirac::TransformByteIO::TransformByteIO | ( | PictureParams & | fparams,
|  | CodecParams & | c_params
| ) |  |

Parameters:

  fparams | Picture parameters
  c_params | Codec params

dirac::TransformByteIO::TransformByteIO | ( | ByteIO & | byte_io,
|  | PictureParams & | fparams,
|  | CodecParams & | c_params
| ) |  |

Parameters:

  byte_io | ByteIO object for copy constructor
  fparams | Picture parameters
  c_params | Codec params

virtual dirac::TransformByteIO::~TransformByteIO | ( |  | ) |
| virtual

## Member Function Documentation

void dirac::TransformByteIO::AddComponent | ( | ComponentByteIO * | component_byteio | ) |

Parameters:

  component_byteio | Picture-component bytestream

void dirac::TransformByteIO::CollateByteStats | ( | DiracByteStats & | dirac_byte_stats | ) |
| virtual

Parameters:

  dirac_byte_stats | Stats container

Reimplemented from dirac::ByteIO.

virtual const std::string dirac::TransformByteIO::GetBytes | ( |  | ) |
| virtual

Reimplemented from dirac::ByteIO.

int dirac::TransformByteIO::GetSize | ( |  | ) | const
| virtual

Reimplemented from dirac::ByteIO.

void dirac::TransformByteIO::Input | ( |  | ) |

void dirac::TransformByteIO::Output | ( |  | ) |

## Member Data Documentation

std::vector<ComponentByteIO *> dirac::TransformByteIO::m_component_list
| private

CodecParams& dirac::TransformByteIO::m_cparams
| private

CodecParams dirac::TransformByteIO::m_default_cparams
| private

PictureParams& dirac::TransformByteIO::m_fparams
| private

The documentation for this class was generated from the following file:

- transform_byteio.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.